// Demonstrates usage of the new udpServer feature.
// You can register the same function to multiple ports,
// and multiple functions to the same port.
// 2013-4-7 Brian Lee <cybexsoft@hotmail.com>
// License: GPLv2

// PIN Connections (Using Arduino UNO):
//   VCC -   3.3V
//   GND -    GND
//   SCK - Pin 13
//   SO  - Pin 12
//   SI  - Pin 11
//   CS  - Pin 10

// 06.04.2019 - erste Version mit Uno auf Testpappe

String Version = "V 2019-04-07 22";
#include <EtherCard.h>
// #include <IPAddress.h>

// String Version = "V 2019-04-07 21";

#define STATIC 1  // 1 disable DHCP / 0 = DHCP
#if STATIC
static byte myip[] = { 192,168,177,255 }; // eigene IP
static byte gwip[] = { 192,168,177,198 }; // Gateway IP
static byte dnsip[] = { 8,8,4,4 }; // Nameserver
#endif
static byte mymac[] = { 0x70,0x69,0x69,0x2D,0x30,0x31 };
byte Ethernet::buffer[400]; // tcp/ip send and receive buffer

void setup(){
  //register udpSerialPrint() to port 514
  ether.udpServerListenOnPort(&udpSerialPrint, 514);

  Serial.begin(57600);
  Serial.println(F("UDP-Logger - mk"));
  Serial.println(Version);

// Change 'SS' to your Slave Select pin, if you arn't using the default pin
  if (ether.begin(sizeof Ethernet::buffer, mymac, SS) == 0)
    Serial.println(F("Failed to access Ethernet controller"));
#if STATIC
  ether.staticSetup(myip, gwip, dnsip);
#else
  if (!ether.dhcpSetup())
    Serial.println(F("DHCP failed"));
#endif

  ether.printIp("IP:  ", ether.myip);
  ether.printIp("GW:  ", ether.gwip);
  ether.printIp("DNS: ", ether.dnsip);
} // Ende setup

void loop(){
  //this must be called for ethercard functions to work.
  ether.packetLoop(ether.packetReceive());
} // Ende loop

//callback that prints received packets to the serial port
void udpSerialPrint(uint16_t dest_port, uint8_t src_ip[IP_LEN], uint16_t src_port, const char *data, uint16_t len){
//  IPAddress src(src_ip[0],src_ip[1],src_ip[2],src_ip[3]);

//  Serial.print("dest_port: ");
//  Serial.println(dest_port);
//  Serial.print("src_port: ");
//  Serial.println(src_port);
//
//  Serial.print("src_ip: ");
//  ether.printIp(src_ip);
//  Serial.println("");
  Serial.println(data);
} // Ende udpSerialPrint
